<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for consigmentDetailAddressDataListType StructType
 * @subpackage Structs
 */
class ConsigmentDetailAddressDataListType extends AbstractStructBase
{
    /**
     * The consigmentDetailAddressData
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\ConsigmentDetailAddressDataType[]
     */
    public $consigmentDetailAddressData;
    /**
     * Constructor method for consigmentDetailAddressDataListType
     * @uses ConsigmentDetailAddressDataListType::setConsigmentDetailAddressData()
     * @param \StructType\ConsigmentDetailAddressDataType[] $consigmentDetailAddressData
     */
    public function __construct(array $consigmentDetailAddressData = array())
    {
        $this
            ->setConsigmentDetailAddressData($consigmentDetailAddressData);
    }
    /**
     * Get consigmentDetailAddressData value
     * @return \StructType\ConsigmentDetailAddressDataType[]|null
     */
    public function getConsigmentDetailAddressData()
    {
        return $this->consigmentDetailAddressData;
    }
    /**
     * This method is responsible for validating the values passed to the setConsigmentDetailAddressData method
     * This method is willingly generated in order to preserve the one-line inline validation within the setConsigmentDetailAddressData method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateConsigmentDetailAddressDataForArrayConstraintsFromSetConsigmentDetailAddressData(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $consigmentDetailAddressDataListTypeConsigmentDetailAddressDataItem) {
            // validation for constraint: itemType
            if (!$consigmentDetailAddressDataListTypeConsigmentDetailAddressDataItem instanceof \StructType\ConsigmentDetailAddressDataType) {
                $invalidValues[] = is_object($consigmentDetailAddressDataListTypeConsigmentDetailAddressDataItem) ? get_class($consigmentDetailAddressDataListTypeConsigmentDetailAddressDataItem) : sprintf('%s(%s)', gettype($consigmentDetailAddressDataListTypeConsigmentDetailAddressDataItem), var_export($consigmentDetailAddressDataListTypeConsigmentDetailAddressDataItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The consigmentDetailAddressData property can only contain items of type \StructType\ConsigmentDetailAddressDataType, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set consigmentDetailAddressData value
     * @throws \InvalidArgumentException
     * @param \StructType\ConsigmentDetailAddressDataType[] $consigmentDetailAddressData
     * @return \StructType\ConsigmentDetailAddressDataListType
     */
    public function setConsigmentDetailAddressData(array $consigmentDetailAddressData = array())
    {
        // validation for constraint: array
        if ('' !== ($consigmentDetailAddressDataArrayErrorMessage = self::validateConsigmentDetailAddressDataForArrayConstraintsFromSetConsigmentDetailAddressData($consigmentDetailAddressData))) {
            throw new \InvalidArgumentException($consigmentDetailAddressDataArrayErrorMessage, __LINE__);
        }
        $this->consigmentDetailAddressData = $consigmentDetailAddressData;
        return $this;
    }
    /**
     * Add item to consigmentDetailAddressData value
     * @throws \InvalidArgumentException
     * @param \StructType\ConsigmentDetailAddressDataType $item
     * @return \StructType\ConsigmentDetailAddressDataListType
     */
    public function addToConsigmentDetailAddressData(\StructType\ConsigmentDetailAddressDataType $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\ConsigmentDetailAddressDataType) {
            throw new \InvalidArgumentException(sprintf('The consigmentDetailAddressData property can only contain items of type \StructType\ConsigmentDetailAddressDataType, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->consigmentDetailAddressData[] = $item;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\ConsigmentDetailAddressDataListType
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
